<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>propclass/evolve.h Source File (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">propclass/evolve.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    Crystal Space Entity Layer</span>
<a name="l00003"></a>00003 <span class="comment">    Copyright (C) 2007 by Jorrit Tyberghein</span>
<a name="l00004"></a>00004 <span class="comment"></span>
<a name="l00005"></a>00005 <span class="comment">    Genetic Algorithm Property Class</span>
<a name="l00006"></a>00006 <span class="comment">    Copyright (C) 2007 by Mat Sutcliffe</span>
<a name="l00007"></a>00007 <span class="comment"></span>
<a name="l00008"></a>00008 <span class="comment">    This library is free software; you can redistribute it and/or</span>
<a name="l00009"></a>00009 <span class="comment">    modify it under the terms of the GNU Library General Public</span>
<a name="l00010"></a>00010 <span class="comment">    License as published by the Free Software Foundation; either</span>
<a name="l00011"></a>00011 <span class="comment">    version 2 of the License, or (at your option) any later version.</span>
<a name="l00012"></a>00012 <span class="comment"></span>
<a name="l00013"></a>00013 <span class="comment">    This library is distributed in the hope that it will be useful,</span>
<a name="l00014"></a>00014 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00015"></a>00015 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00016"></a>00016 <span class="comment">    Library General Public License for more details.</span>
<a name="l00017"></a>00017 <span class="comment"></span>
<a name="l00018"></a>00018 <span class="comment">    You should have received a copy of the GNU Library General Public</span>
<a name="l00019"></a>00019 <span class="comment">    License along with this library; if not, write to the Free</span>
<a name="l00020"></a>00020 <span class="comment">    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.</span>
<a name="l00021"></a>00021 <span class="comment">*/</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="preprocessor">#ifndef __CEL_PF_EVOLVE__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span><span class="preprocessor">#define __CEL_PF_EVOLVE__</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cstypes_8h.html">cstypes.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/scf_8h.html">csutil/scf.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/refcount_8h.html">csutil/refcount.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/csutil_2array_8h.html">csutil/array.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;physicallayer/datatype.h&quot;</span>
<a name="l00032"></a>00032 
<a name="l00061"></a><a class="code" href="structiPcEvolve.html">00061</a> <span class="keyword">struct </span><a class="code" href="structiPcEvolve.html" title="A property class implementing a genetic algorithm.">iPcEvolve</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00062"></a>00062 {
<a name="l00063"></a>00063   SCF_INTERFACE(<a class="code" href="structiPcEvolve.html" title="A property class implementing a genetic algorithm.">iPcEvolve</a>, 0, 0, 1);
<a name="l00064"></a>00064 
<a name="l00068"></a>00068   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcEvolve.html#a71d414b94496d2d86b8c72ebbb6e5ad9" title="Sets the population size (number of individual genomes).">SetPopulationSize</a>(<span class="keywordtype">size_t</span> size) = 0;
<a name="l00069"></a>00069 
<a name="l00073"></a>00073   <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> <a class="code" href="structiPcEvolve.html#ae21546b6edf6d377cc36e6c93dfddee3" title="Returns the population size (number of individual genomes).">GetPopulationSize</a>() <span class="keyword">const</span> = 0;
<a name="l00074"></a>00074 
<a name="l00079"></a>00079   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcEvolve.html#a51b65994a43befc0dd0b4aa968fc98dd" title="Sets the subject property class (the property class that will be evolved by this one).">SetSubject</a>(<a class="code" href="structiCelPropertyClass.html" title="This is a property class for an entity.">iCelPropertyClass</a> *pc) = 0;
<a name="l00080"></a>00080 
<a name="l00085"></a>00085   <span class="keyword">virtual</span> <a class="code" href="structiCelPropertyClass.html" title="This is a property class for an entity.">iCelPropertyClass</a>* <a class="code" href="structiPcEvolve.html#a4a5d3882ec4820f5baa094932f68d95c" title="Returns the subject property class (the property class being evolved by this one.">GetSubject</a>() = 0;
<a name="l00086"></a>00086 
<a name="l00098"></a>00098   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcEvolve.html#ab634e24030ad6811b07c010dd2d2dc8a" title="Sets the probability parameters for the stochastic (non-deterministic) randomness of the genetic algo...">SetProbabilities</a>(<span class="keywordtype">float</span> select, <span class="keywordtype">float</span> mutate) = 0;
<a name="l00099"></a>00099 
<a name="l00105"></a>00105   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcEvolve.html#a3741ab18728799a707f8c9d0ef659733" title="Instructs the property class to begin the evolution of one generation.">Generate</a>() = 0;
<a name="l00106"></a>00106 
<a name="l00112"></a>00112   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcEvolve.html#a7f3d8ff4fb2d4628b75198901a1f9ff2" title="Informs the property class that the fitness of a genome has been evaluated, as requested by the &quot;pcev...">FitnessCallback</a>(<span class="keywordtype">float</span> fitness) = 0;
<a name="l00113"></a>00113 
<a name="l00120"></a>00120   <span class="keyword">virtual</span> <span class="keywordtype">float</span> <a class="code" href="structiPcEvolve.html#a59b45cecc3d2f4a44f372c02669a36cd" title="Returns the fitness of the genome specified by the index parameter.">GetFitness</a>(<span class="keywordtype">size_t</span> index) <span class="keyword">const</span> = 0;
<a name="l00121"></a>00121 
<a name="l00128"></a>00128   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcEvolve.html#a5128dd26715355a025b0558d24ae44fe" title="Stored the genome specified by the index parameter into the subject property class.">SelectGenome</a>(<span class="keywordtype">size_t</span> index) = 0;
<a name="l00129"></a>00129 
<a name="l00134"></a>00134   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcEvolve.html#a7a19501d4d49ad74ca71910917a8465c" title="Resets the property class to its initial state before Generate() was first called.">ResetPopulation</a>() = 0;
<a name="l00135"></a>00135 };
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 <span class="preprocessor">#endif // __CEL_PF_EVOLVE__</span>
<a name="l00138"></a>00138 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
